#include <vector>
#include <Windows.h>
#include <sigscanner.h>
#include <MinHook.h>
#include <thread>
#include <chrono>
#include <atomic>

DWORD addrSomeRandomFuncReferencingHostingObject = NULL;
int(__stdcall *addrShowChatMessage)(DWORD a1, int color, char *smg, int unk);
DWORD addrHostObject = NULL;
DWORD addrConstructResources = NULL;
int(__stdcall *origConstructResources)(int a1);
DWORD addrOnChatInput = NULL;
DWORD origOnChatInput = NULL;
DWORD addrResourceObject = NULL;

int callShowChatMessage(char * msg, int color) {
	if (!addrResourceObject) return -1;
	return addrShowChatMessage(addrResourceObject, color, msg, 1);
}

int __stdcall callOriginalOnChatInput(int a1, char * msg, int a3) {
	_asm mov ecx, a1
	_asm mov eax, msg
	_asm push a3
	_asm call origOnChatInput
}

struct SlotData {
	int number;
	DWORD addr;
	int sock;
	const char * slotnick;
};
SlotData invalidSlot = {-1, 0xdeadc0de, -1, "[invalid slot"};

SlotData getSlotData(int number) {
	if(number < 0 || number > 6) return invalidSlot;
	SlotData data;
	data.number = number;
	data.addr = (int)addrHostObject + 0x1A4 + number * 0x19118;
	data.sock = *(int*)(data.addr + 0x8C);
	data.slotnick = (const char*)(data.addr + 0xD0);
	return data;
}

int checkSlotByName(char * nickname) {
	for(int number=0; number < 6; number++) {
		SlotData data = getSlotData(number);
		if(data.sock >= 0 && nickname && data.slotnick && !strcmp(nickname, data.slotnick)) {
			return number;
		}
	}
	return -1;
}

bool enqueuePlayerKick(int number) {
	static std::atomic<bool> running = false;
	if(!running) {
		std::thread t([=](){
			running = true;
			using namespace std::chrono_literals;
			std::this_thread::sleep_for(5s);
			SlotData data = getSlotData(number);
			if(data.sock >= 0) {
				(*(void (__thiscall **)(int))(*(int *)data.addr + 496))(data.addr);
			}
			running = false;
		});
		t.detach();
		return true;
	}
	return false;
}

int onChatInput(int a1, char * msg, int a3) {
	if(!strncmp(msg, "/kick", 5)) {
		char buff[256];
		size_t len = strlen(msg);
		SlotData data = invalidSlot;
		if(len == 6) {
			//handle "/kick#" commands
			char slot = msg[5] - '1';
			data = getSlotData(slot);
			if(data.sock < 0) {
				sprintf_s(buff, "wkKick38: Player #%d not found", slot + 1);
				callShowChatMessage(buff, 6);
			}
		}
		else if(len > 6 && len < 128 && !strncmp(msg, "/kick ", 6)) {
			//handle "/kick nickname" commands
			char * nickname = msg + 6;
			int slot = checkSlotByName(nickname);
			data = getSlotData(slot);
			if(data.sock < 0) {
				sprintf_s(buff, "wkKick38: Player %s not found", nickname);
				callShowChatMessage(buff, 6);
			}
		} else {
			callShowChatMessage("wkKick38: usage: /kick nickname   OR   /kick#", 6);
		}

		if(data.sock >= 0) {
			if(enqueuePlayerKick(data.number)) {
				sprintf_s(buff, "/me is kicking out player %s     (wkKick38)", data.slotnick);
				callOriginalOnChatInput(a1, buff, a3);
			}
		}
		return 1;
	}
	return 0;
}

int __stdcall hookConstructResources(int a1) {
	addrResourceObject = a1;
	return origConstructResources(a1);
}

#pragma optimize( "", off )
char* onchat_eax;
int onchat_ecx;
void __stdcall hookOnChatInput(int a3) {
	_asm mov onchat_eax, eax
	_asm mov onchat_ecx, ecx
	if(!onChatInput(onchat_ecx, (char*)onchat_eax, a3)) {
		callOriginalOnChatInput(onchat_ecx, onchat_eax, a3);
	}
}
#pragma optimize( "", on )

void hook(std::string name, DWORD pTarget, DWORD *pDetour, DWORD *ppOriginal) {
	if(!pTarget)
		throw std::runtime_error("Hook adress is null: " + name);
	if(MH_CreateHook((LPVOID)pTarget, (LPVOID)pDetour, (LPVOID*)ppOriginal) != MH_OK)
		throw std::runtime_error("Failed to create hook: " + name);
	if(MH_EnableHook((LPVOID)pTarget) != MH_OK)
		throw std::runtime_error("Failed to enable hook: " + name);
}

void scanMemoryAndHook() {
	SignatureScanner SigScanner;
	SigScanner.GetProcess();
	module mod = SigScanner.GetModule();
	if(!mod.dwBase)
		throw std::runtime_error("Failed to initialize signature scanner");
	if (MH_Initialize() != MH_OK)
		throw std::runtime_error("Failed to initialize Minhook");

	addrSomeRandomFuncReferencingHostingObject = SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x56\x57\xBE\x00\x00\x00\x00\x8B\xF9\xE8\x00\x00\x00\x00\x68\x00\x00\x00\x00\x8B\xF7\xE8\x00\x00\x00\x00", "???????xxx????x????xxx????"); //481E80
	if(!addrSomeRandomFuncReferencingHostingObject)
		throw std::runtime_error("Failed to find addrHostObject");
	addrHostObject = *(DWORD*)(addrSomeRandomFuncReferencingHostingObject + 3);

	addrShowChatMessage = (int (__stdcall *)(DWORD,int,char *,int)) SigScanner.FindSignature(mod.dwBase, mod.dwSize,  "\x81\xEC\x00\x00\x00\x00\x53\x55\x8B\xAC\x24\x00\x00\x00\x00\x80\xBD\x00\x00\x00\x00\x00\x8B\x85\x00\x00\x00\x00\x8B\x48\x24\x56\x8B\xB1\x00\x00\x00\x00\x57", "??????xxxxx????xx?????xx????xxxxxx????x"); //52AB70
	if(!addrShowChatMessage)
		throw std::runtime_error("Failed to find addrShowChatMessage");

	addrConstructResources = SigScanner.FindSignature(mod.dwBase, mod.dwSize,  "\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x83\xEC\x24\x53\x55\x8B\x6C\x24\x3C\x8B\x85\x00\x00\x00\x00\x8B\x48\x24", "???????xx????xxxx????xxxxxxxxxxx????xxx"); //5263C0
	addrOnChatInput =  SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x81\xEC\x00\x00\x00\x00\x55\x56\x57\x8B\xF8\x8A\x07\x84\xC0\x8B\xF1\x0F\x84\x00\x00\x00\x00\x3C\x2F\x0F\x85\x00\x00\x00\x00\x8D\x44\x24\x40", "??????xxxxxxxxxxxxx????xxxx????xxxx"); //0052B5F0

	hook("ConstructResources", addrConstructResources, (DWORD*)&hookConstructResources, (DWORD*)&origConstructResources);
	hook("OnChatInput", addrOnChatInput, (DWORD*)&hookOnChatInput, (DWORD*)&origOnChatInput);
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, DWORD lpReserved) {
	switch(ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			try {
				scanMemoryAndHook();
			} catch(std::exception & e) {
				MessageBoxA(0, e.what(), "wkKick38", MB_ICONERROR);
			}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		default:
			break;
	}
	return TRUE;
}
